#include "mbed.h"

Serial serial(SERIAL_TX, SERIAL_RX);

DigitalOut myled(LED1);

Ticker ticker;

void tick()
{
    myled = !myled;
}

int main()
{
    serial.baud(115200);
    for (int i = 0; i < 5*2; ++i) { // 5x zablikání LED s periodou 50 ms
        myled = !myled;
        wait(0.05);
    }
    myled = 0;
    while(serial.readable()) { // flush the input buffer
        serial.getc();
    }
    float periods[] = { 0.05, 0.1, 0.2, 0.5, 1.0 };
    serial.putc('i');
    int quit = 0;
    int blink = 0;
    while (!quit) {
        if (serial.readable()) {
            int c = serial.getc();
            char response = 'a';
            switch(c) {
                case 's':
                    ticker.detach();
                    myled = 1;
                    blink = myled;
                    break;
                case 'e':
                    ticker.detach();
                    myled = 0;
                    blink = myled;
                    break;
                case 'h':
                    response = 'h';
                    break;
                case 'b':
                    response = 'b';
                    quit = 1;
                    break;
                default:
                    if (c >= '1' && c <= '5') {
                        ticker.attach(tick, periods[c-'1']);
                    } else {
                        response = 'f';
                    }
                    break;
            }
            while (!serial.writeable()) {}
            serial.putc(response);
        } else if (blink != myled) {
            while (!serial.writeable()) {}
            blink = myled;
            serial.putc(blink ? 'x' : 'o');
        }
    } // end while (!quit)
}
